<?php
///===================================================================================
///                                                  Fichier : install_MotsCles.php
///===================================================================================
///
/// Installation du package SPIP-XML (fichier  inclure)
///
///    Cration de groupes de mots cls
///
/// Paramtres
///    $groups            $groups[type][0] = 'PourArticles;PourRubriques'; // Au choix...
///                       $groups[type][i] = mot-cl;                      // Vide si groupe seul
///
///    $dirModelesImport  Chemin vers le rpertoire contenant les modles d'importation
///
/// NB: Le groupe 'TypeFicheXML' sera cr (ou enrichi s'il existe dj)
///     d'aprs les modles prsents dans le rpertoire 'Tools/Modeles_fiches_XML'.
///
///===================================================================================
/// Rechercher les mots-cls existants

    $groupesExistant = array();

    $sql = "SELECT id_groupe,titre FROM spip_groupes_mots";
    $res = spip_query($sql);
    while( list($id_groupe, $titre)=mysql_fetch_row($res) ) {
      $groupesExistant[$titre] = array($id_groupe);
    }
    mysql_free_result($res);

    $sql = "SELECT id_mot,titre,type FROM spip_mots ";
    $res = spip_query($sql);
    while( list($id_mot,$mot,$type)=mysql_fetch_row($res) ) {
      $groupesExistant[$type][$mot] = $id_mot;
    }
    mysql_free_result($res);

//------------------------------------------------------------------------------------
/// Groupe 'TypeFicheXML' => Rechercher les modles de fiche distribus

    $groups['TypeFicheXML']    = array('PourArticles;PourRubriques');

    $dirModelesFichesXML = 'Tools/Modeles_fiches_XML';
    $dirh = opendir($dirModelesFichesXML);
    while($file = readdir($dirh)) {
      if($file=='.' || $file=='..') { continue; }
      $typeModele = str_replace('.xml', '', $file);
      $typeFiche  = str_replace('Modele', '', $typeModele);

      $groups['TypeFicheXML'][] = $typeFiche;
    }

//------------------------------------------------------------------------------------
/// Balayer les groupes  crer

    foreach($groups as $group => $mots) {

      $attributs = array( 'TypeMot' => $group );          // Reset !
?>
    <table width='90%' cols='2'>
      <tr><td width='50%' valign='top'>Groupe de mots-cls "<b><?=$group?></b>"

<?
//------------------------------------------------------------------------------------
/// Destination du groupe (articles, rubriques, ...)
      $dest = array_shift( $mots );                       // Destination retire...

//------------------------------------------------------------------------------------
/// Traiter un groupe existant
      if($groupesExistant[$group]) {
        $attributs['id_groupe'] = $groupesExistant[$group][0];
?>
        => Existant...</td><td width='50%'>
<?
      } else {
//------------------------------------------------------------------------------------
/// Crer un nouveau groupe
        if($dest) {
          $dest = explode(';', $dest);
          foreach($dest as $pour) $attributs[$pour] = 'oui';
        }
        importObjectIntoSpip('Groupe_Mots', $attributs);  // cf. import_Groupe_Mots_std.xml
        $groupesExistant[$group] = array( $attributs['id_groupe'] );
?>
        => Cr...</td><td width='50%'>
<?
      } // Fin if($groupesExistant[$group])... else

///------------------------------------------------------------------------------------
/// Balayer les mots du groupe
      foreach($mots as $mot) {
?>
        Mots-cl "<b><?=$mot?></b>"
<?
//------------------------------------------------------------------------------------
/// Traiter un mot existant
        if($groupesExistant[$group] && $groupesExistant[$group][$mot]) {
?>
          => Existant...<br />
<?
        } else {
//------------------------------------------------------------------------------------
/// Crer les nouveaux mots-cls
          $attributs['id_mot'] = 0;
          $attributs['TitreMot'] = $mot;
          importObjectIntoSpip('Mot', $attributs);        // cf. import_Mot_std.xml
          $groupesExistant[$group][$mot] = $attributs['id_mot'];
?>
        => Cr...<br />
<?
        } // Fin if($groupesExistant[$group] && $groupesExistant[$group][$mot])
        flush();

      } // Fin foreach($mots as $mot)
?>
        </td>
      </tr>
    </table>
<?
      flush();

    } // Fin foreach($groups as $group => $mots)

if($debugAppli) $debugAppli->show($groups,'Mots-cls : groups');
//------------------------------------------------------------------------------------
?>
