<?php
///===================================================================================
///                                                  Fichier : install_Modeles.php
///===================================================================================
///
/// Installation du package SPIP-XML
///
///   Cration des articles "Modle de Fiche XML"
///
/// Paramtres
///
///===================================================================================

/// Prvenir si un modle d'importation dans Spip existe dans le rpertoire "PathToImportModels"
/// ... et ne rien mettre  jour !

    $dirImportModels = 'Tools/Modeles_import';
    if($PathToImportModels && ($PathToImportModels!=$dirImportModels)) {

/// Balayer le rpertoire contenant les modles d'importation dans Spip
?>
      <table width='90%' cols='2'>
        <tr><td width='50%' valign='top' colspan='2'>
              Vrification des modles d'importation livrs
              et dj prsents dans le rpertoire "<?=$PathToModelsXml?>"
              (cf. paramtre 'PathToModelsXml' de la table MySQL '<?=$table_prefix?>_params_appli')
            </td>
        </tr>
<?
      $dirh = opendir($dirImportModels);
      while($file = readdir($dirh)) {

        if($file=='.' || $file=='..') { continue; }
        $typeObjet = ereg_replace('^import_([^_]*)_.*$', '\1', $file);
        $nomObjet  = ereg_replace('^import_[^_]*_([^_.]*)[_.].*$', '\1', $file);
?>
        <tr><td width='50%' valign='top'>
              Modle d'importation <b><?=$typeObjet?>=<?=$nomObjet?></b>
            </td>
            <td width='50%' valign='top'>
<?
        if(is_file("$PathToImportModels/$file")) {
?>
              <font color='red'>
                Existe dj => Mettez-le  jour manuellement  partir du fichier "<?="$dirImportModels/$file"?>"<br />
                &nbsp;<br />
              </font>
<?
/// Sinon, copier ventuellement le modle dans ce rpertoire
        } else { // Suite if(is_file("$PathToImportModels/$file"))

          copy("$dirImportModels/$file", "$PathToImportModels/$file");
?>
              Copi dans ce rpertoire<br />
<?
        } // Fin if(is_file("$PathToImportModels/$file"))... else...
?>
          </td>
        </tr>
<?
      } // Fin while($file = readdir($dirh))
      closedir($dirh);

?>
        <tr><td colspan='2'>&nbsp;</td></tr>
      </table>
<?
      flush();

    } // Fin if($PathToImportModels && ($PathToImportModels!=$dirImportModels))

//------------------------------------------------------------------------------------
/// --- Crer la rubrique "Modles de Fiches XML" ---

    $id_secteur = 0;    // A la racine du site
    $id_parent  = 0;
    $titre       = "Modles de Fiches XML";
    $descriptif  = "Cette rubrique contient tous les modles de \"Fiches XML\" ";
    $texte       = " ";

    $GLOBALS['import_InstallRub'] = 'import_Rubrique_Std.xml,'.       // Rubrique standard
                                    'import_Mot_Dummy_Rubrique.xml';  //   + Mot-cl "Dummy"

    include 'Install_SPIP-XML/install_Rubrique.php';

/// Mmoriser les paramtres de la rubrique
    $idRubModeles  = $id_rubrique;
    $idSectModeles = $id_secteur;

/// Rappeler le type d'accs aux modles : fichier ou article Spip
    $dirModelesFichesXML = 'Tools/Modeles_fiches_XML';  // Rpertoire des modles livrs.

    if($PathToModelsXml) {
      $accesModele  = "Dans la table MySQL '$table_prefix"."_appli_params', la variable 'PathToModelsXml' est renseigne  '$PathToModelsXml'...";
      $accesModele .= "<br /><b>Les modles utiliss seront donc les fichiers du rpertoire '$PathToModelsXml'</b> ";
      $accesModele .= "et les articles Spip identifiant les modles seront rduits  la seule balise '&lt;DocumentXML>'.";
      if($PathToModelsXml!=$dirModelesFichesXML)
        $accesModele .= "<br />NB: Les fichiers contenant les modles livrs seront copis dans le rpertoire '$PathToModelsXml'.";
    } else {
      $accesModele  = "Dans la table MySQL '$table_prefix"."_appli_params', la variable 'PathToModelsXml' n'est pas renseigne...";
      $accesModele .= "<br /><b>Les modles utiliss seront donc les articles de la rubrique 'Modles de Fiches XML'</b>.";
    }
    $accesModele .= "<br />NB: Les articles Spip de la rubrique 'Modles de Fiches XML' sont crs ci-aprs...";
?>
    <table width='90%' cols='2'>
      <tr><td valign='top' colspan='2' align='left'><?=$accesModele?><br />&nbsp;</td><td></td></tr>
    </table>
<?
//------------------------------------------------------------------------------------
/// --- Crer les modles des fiches XML ---

    $GLOBALS['import_ArtModele'] = 'import_Article_Std.xml,'.         // Article standard
                                   'import_Mot_ModeleFicheXML.xml';   //   + Mot-cl "ModeleFicheXML"

/// Balayer le rpertoire contenant les modles de fiches XML
    $dirh = opendir($dirModelesFichesXML);

    while($file = readdir($dirh)) {

      $fic = "$dirModelesFichesXML/$file";

      if($file=='.' || $file=='..') { continue; }
      $typeModele = str_replace('.xml', '', $file);
      $typeFiche  = str_replace('Modele', '', $typeModele);

      $installModele = 1;
?>
    <table width='90%' cols='2'>
      <tr><td width='50%' valign='top'>Modle pour les fiches XML de type "<b><?=$typeFiche?></b>"<br />
<?
//------------------------------------------------------------------------------------
/// Prvenir si le modle existe dans le rpertoire ventuel donn par 'PathToModelsXml'...
/// ... et ne rien mettre  jour !

      if($PathToModelsXml && ($PathToModelsXml!=$dirModelesFichesXML)) {
        if(is_file("$PathToModelsXml/$file")) {
          $installModele = 0;     // Ne pas installer le modle (installation manuelle)
?>
            <b>Ce modle existe dj dans le rpertoire "<?=$PathToModelsXml?>"</b>
            (cf. paramtre 'PathToModelsXml' de la table MySQL '<?=$table_prefix?>_params_appli')<br />&nbsp;
          </td>
          <td width='50%' valign='top'><font color='red'>
            <b>Il n'est donc pas mis  jour</b>, ni dans ce rpertoire, ni dans l'article Spip associ.<br />
            NB : Reportez manuellement les ventuelles volutions  partir du fichier "<?=$fic?>".<br />&nbsp;
            </font>
          </td>
<?
/// Copier ventuellement le modle dans ce rpertoire
        } else {

          copy("$dirModelesFichesXML/$file", "$PathToModelsXml/$file");
?>
            => <b><?=$typeModele?></b> copi dans le rpertoire "<?=$PathToModelsXml?>"</b><br />
<?
        } // Fin if(is_file("$PathToModelsXml/$file"))... else...
      } // Fin if($PathToModelsXml && ...)

///------------------------------------------------------------------------------------
/// --- Installer le modle ---

      if($installModele) {

/// Lire le fichier contenant le modle
        $fh = fopen($fic, 'r');
           $modele = fread($fh, filesize($fic));
        fclose($fh);

/// En extraire le titre (label du lien de cration)
        $balises = balisesXML($modele);
        $titre   = $balises['TitreModele'];

/// Rduire le modle  la seule balise "DocumentXML" si les fichiers sont utiliss
/// (au lieu des articles)
        if($PathToModelsXml)
          $modele = ereg_replace('(<DocumentXML[^>]*>).*$', '\1', $modele) .'</DocumentXML>';

/// Rechercher un modle existant
    		$id_article = 0;
        $sql = "SELECT art.id_article, art.id_rubrique, art.id_secteur ".
               "FROM spip_articles AS art, spip_mots AS mots, spip_mots_articles AS rel_mots ".
               "WHERE mots.titre='ModeleFicheXML' ".            // Le modle a le mot-cl "ModeleFicheXML"...
               "  AND rel_mots.id_mot=mots.id_mot ".
               "  AND art.id_article=rel_mots.id_article ".
               "  AND art.surtitre='$typeModele' ";             // ... et le surtitre "Modele<TypeFicheXML>"
        $res = spip_query($sql);

        if( $res && mysql_num_rows($res)!=0 )
          list($id_article,$id_rubrique,$id_secteur) = mysql_fetch_row($res);
        else {
          $id_article  = 0;
          $id_rubrique = $idRubModeles;
          $id_secteur  = $idSectModeles;
        }

        @mysql_free_result($res);

/// Traiter un modle existant
        if($id_article) {
?>
          => Article existant... Mis  jour
<?
/// Traiter un nouveau modle
        } else {
          $id_rubrique = $idRubModeles;
          $id_secteur  = $idSectModeles;
?>
          => Article cr
<?
        }
?>
            </td>
            <td width='50%' valign='top'>
<?
// Masquer les balises XML de la fiche pendant l'analyse du modele d'importation (en XML aussi!)
        $modele = str_replace('<','&lt;', str_replace('&','&amp;', $modele));

/// Crer ou mettre  jour le modle
        $attributs = array( 'id_article'         => $id_article,
                            'id_rubrique'        => $id_rubrique,
                            'id_secteur'         => $id_secteur,
                            'TitreArticle'       => $titre,
                            'SurTitreArticle'    => $typeModele,
                            'TexteArticle'       => $modele
                          );

        importObjectIntoSpip('ArtModele', $attributs);

/// ...et rcuprer son id
        $sql = "SELECT id_article,id_rubrique,id_secteur ".
               " FROM  spip_articles ".
               " WHERE id_article=".$attributs['id_article'];
        $res = spip_query($sql);
        list($id_article,$id_rubrique,$id_secteur) = mysql_fetch_row($res);
        mysql_free_result($res);
?>
          [id_article=<?=$id_article?>]<br/ >[id_rubrique=<?=$id_rubrique?>]<br />[id_secteur=<?=$id_secteur?>]
        </td>
<?
      } // Fin if($installModele)
?>
      </tr>
    </table>
<?
    flush();

    } // Fin while($file = readdir($dirh))
    closedir($dirh);

//------------------------------------------------------------------------------------
?>
